import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Box;

/**
 * ワープ
 */
public class ARSpriteWarp extends ARSprite {

	/** マテリアル */
	private static final PhongMaterial		MATERIALS		= new PhongMaterial(Color.color(0.9, 0.9, 0.0, 0.3));

	/** アプリケーション */
	public		ARApplication				application		= null;

	/** ワープ */
	private		Box							boxWarp			= null;

	/** 時間 */
	private		int							time			= 0;

	/**
	 * コンストラクタ
	 * @param application ARApplication
	 * @param spriteShip ARSprite 自機
	 */
	public ARSpriteWarp(ARApplication application, ARSpriteShip spriteShip) {

		super(application);

		// アプリケーションを保持
		this.application = application;

		// ワープ生成
		boxWarp = new Box(0.8, 0.4, 0.0);

		// マテリアルを設定
		boxWarp.setMaterial(MATERIALS);

		// 座標初期化
		boxWarp.setTranslateX(spriteShip.getTranslateX());
		boxWarp.setTranslateY(spriteShip.getTranslateY());
		boxWarp.setTranslateZ(300);

		// ワープ追加
		this.getChildren().add(boxWarp);

	} // end ARSpriteWarp

	/**
	 * 実行
	 */
	public void run(){

		// 時間＋１
		time++;

		// １秒、
		if(time < 60){

			// 奥行き計算
			double depth = time / 60.0 * 300;

			// 奥行き中心点計算
			double zCenter = 300 - depth / 2;

			// 座標設定
			boxWarp.setTranslateZ(zCenter);

			// 奥行き設定
			boxWarp.setDepth(depth);

		// ３.５秒、
		}else if(time < 210){

			// なにもしない

		// ４．５秒
		}else if(time < 270){

			// 時間計算
			int time1 = 60 - (time - 210);

			// 奥行き計算
			double depth = time1 / 60.0 * 300;

			// 奥行き中心点計算
			double zCenter = 300 - depth / 2;

			// 座標設定
			boxWarp.setTranslateZ(zCenter);

			// 奥行き設定
			boxWarp.setDepth(depth);

		// ４．５秒
		}else if(time == 270){

			// アプリケーションからノード削除
			application.removeNode(this);

		} // end if

	} // end run

}
